package net.zmobile.ui;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

import net.zmobile.ZMobile;

public class ZButton extends ZComponent {

	Image _image = null;

	public ZButton(String text) {
		this.setText(text);
		this._w = Font.getDefaultFont().stringWidth(text);
		this._h = Font.getDefaultFont().getHeight();
	}

	public ZButton(Image image) {
		if (image == null)
			throw new RuntimeException("Error");
		_image = image;
		this._w = image.getWidth();
		this._h = image.getHeight();
	}

	public void draw(Graphics g) {
		if (_font != null) {
			g.setFont(_font);
		}
		g.setColor(192, 192, 192);
		g.fillRect(_x + ZMobile.GRAP, _y + ZMobile.GRAP, _w - 2 * ZMobile.GRAP,
				_h - 2 * ZMobile.GRAP);
		g.setColor(0);
		Font font = g.getFont();
		if (_image != null) {
			g.setColor(0x0);
			g.drawRect(_x, _y, _w, _h);
			g.drawImage(_image, _x, _y, Graphics.TOP | Graphics.LEFT);
		} else {
			g.setColor(0x0);
			g.drawRect(_x + ZMobile.GRAP, _y + ZMobile.GRAP, _w - 2
					* ZMobile.GRAP, _h - 2 * ZMobile.GRAP);
			g.drawString(_text, _x + _w / 2 - font.stringWidth(_text) / 2, _y
					+ _h / 2 - font.getHeight() / 2, Graphics.TOP
					| Graphics.LEFT);
		}
	}

	public void drawStatus(Graphics g) {
		if (this.isFoucus) {
			g.setColor(0x0000ff);
			if(this.isPressed){
				g.setColor(0xff0000);
			}
		}else{
			return;
		}
		
		g.drawRect(_x + ZMobile.GRAP, _y + ZMobile.GRAP, _w - 2
				* ZMobile.GRAP, _h - 2 * ZMobile.GRAP);
		g.drawRect(_x + ZMobile.GRAP + 1, _y + ZMobile.GRAP + 1, _w - 2
				* ZMobile.GRAP - 2, _h - 2 * ZMobile.GRAP - 2);
	}

	public void resetSize() {
		this._w = Font.getDefaultFont().stringWidth(_text);
		this._h = Font.getDefaultFont().getHeight();
	}
}
